//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A92D9FC02A2.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A92D9FC02A2.cm

//## begin module%3A92D9FC02A2.cp preserve=no
//## end module%3A92D9FC02A2.cp

//## Module: MultiResponse%3A92D9FC02A2; Package specification
//## Subsystem: XSModel::Data::Detector%367691B76668
//	/local/data/verisB/dorman/Xspec/src/detector
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/Detector/MultiResponse.h

#ifndef MULTIRESPONSE_H
#define MULTIRESPONSE_H 1

//## begin module%3A92D9FC02A2.additionalIncludes preserve=no
//## end module%3A92D9FC02A2.additionalIncludes

//## begin module%3A92D9FC02A2.includes preserve=yes
//## end module%3A92D9FC02A2.includes

// xsTypes
#include <main/xsTypes.h>
// string
#include <string>
// SpectralData
#include <XSModel/Data/SpectralData.h>
// Reference
#include <XSUtil/Utils/Reference.h>
// Response
#include <XSModel/Data/Detector/Response.h>
// RMF
#include <XSModel/Data/Detector/RMF.h>
//## begin module%3A92D9FC02A2.declarations preserve=no
//## end module%3A92D9FC02A2.declarations

//## begin module%3A92D9FC02A2.additionalDeclarations preserve=yes
//## end module%3A92D9FC02A2.additionalDeclarations


//## begin MultiResponse%3A92D99B0161.preface preserve=yes
//## end MultiResponse%3A92D99B0161.preface

//## Class: MultiResponse%3A92D99B0161
//## Category: XSModel::Data::Detector%36349D570394
//## Subsystem: XSModel::Data::Detector%367691B76668
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A92F4DE030F;RMF { -> }
//## Uses: <unnamed>%3B992508039D;Model { -> }
//## Uses: <unnamed>%3DF61CDF00AF;SumComponent { -> }

class MultiResponse : public Response  //## Inherits: <unnamed>%3A92DB1C0130
{
  //## begin MultiResponse%3A92D99B0161.initialDeclarations preserve=yes
  //## end MultiResponse%3A92D99B0161.initialDeclarations

  public:
    //## Class: positionInfo%3BB884A402AF
    //## Category: XSModel::Data::Detector%36349D570394
    //## Subsystem: XSModel::Data::Detector%367691B76668
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct positionInfo 
    {

        //## Other Operations (specified)
          //## Operation: operator>%3BB885A100CF
          friend bool operator > (const positionInfo& left, const positionInfo& right);

        // Data Members for Class Attributes

          //## Attribute: rmfNum%3BB884D500FD
          //## begin MultiResponse::positionInfo::rmfNum%3BB884D500FD.attr preserve=no  private: size_t {U} 
          size_t rmfNum;
          //## end MultiResponse::positionInfo::rmfNum%3BB884D500FD.attr

          //## Attribute: rmfSize%3BB88538022A
          //## begin MultiResponse::positionInfo::rmfSize%3BB88538022A.attr preserve=no  private: size_t {U} 
          size_t rmfSize;
          //## end MultiResponse::positionInfo::rmfSize%3BB88538022A.attr

          //## Attribute: posValue%3BB885580381
          //## begin MultiResponse::positionInfo::posValue%3BB885580381.attr preserve=no  private: RMF::RMFLONG {U} 
          RMF::RMFLONG posValue;
          //## end MultiResponse::positionInfo::posValue%3BB885580381.attr

          //## Attribute: pos%3BB885920102
          //## begin MultiResponse::positionInfo::pos%3BB885920102.attr preserve=no  private: size_t {U} 
          size_t pos;
          //## end MultiResponse::positionInfo::pos%3BB885920102.attr

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~MultiResponse();


    //## Other Operations (specified)
      //## Operation: operator*%3A92DC01026C; C++
      //	Additional Public Declarations
      virtual Model& operator * (Model& model) const;

      //## Operation: read%3A92DC1B0269
      virtual size_t read (const string& fileName, bool readFlag = true) = 0;

      //## Operation: closeSourceFiles%3A92DC3D006C
      virtual void closeSourceFiles (size_t index = 0) = 0;

      //## Operation: setData%3A92DC4A00C0
      void setData (size_t specNum, size_t groupNumber, size_t nRmf = 0);

      //## Operation: readAuxResponse%3A92DC5403BE
      virtual bool readAuxResponse ();

      //## Operation: clone%3A95670E011C
      virtual MultiResponse* clone () const = 0;

      //## Operation: setEnergies%3AC4BC460355
      virtual void setEnergies ();

      //## Operation: setSharedDescription%3ACA1F610391
      void setSharedDescription (size_t specNum, size_t groupNum);

      //## Operation: prepareForFit%3BB882FB0292
      virtual void prepareForFit ();

      //## Operation: sensitivity%3DE51AFD01C2
      virtual RealArray sensitivity (const SpectralData* data);

      //## Operation: operator*%3DE7CE590200; C++
      //	Convolution method for responses. Input model component,
      //	output folded model component.
      //	      //	For the time being implement output as Real
      //	Array.
      //	For the time being implement output as RealArray.
      //	There might be a better implementation that involved
      //	adding a folded array data member to the Component
      //	class. In the meantime the idea is to output the
      //	RealArray folded component and sum for the total
      //	model.
      //	      //	This must be modified to throw a YellowAlert
      //	Exception
      //	This must be modified to throw a YellowAlert Exception
      //	for invalid computations and to throw standard numeric
      //	exceptions.
      virtual void operator * (SumComponent& source) const;

      //## Operation: makeDerivative%415B0E7F0015
      virtual void makeDerivative (Real delta, RealArray& deriv, Response::ResponseParType parType);

      //## Operation: calcEffAreaPerChan%42273FD1017A
      virtual void calcEffAreaPerChan (RealArray& effArea);

      //## Operation: toMultiResponse%43AC560D006A
      virtual const MultiResponse* toMultiResponse () const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::Detector::MultiRMF Pointer%3A92DCC100AF
      //## Role: MultiResponse::rmfData%3A92DCC30005
      //## Qualifier: rmfNum%3ACE0C400222; size_t
      const std::vector<RefCountPtr< RMF > >& rmfData () const;
      void setRmfData (const std::vector<RefCountPtr< RMF > >& value);
      const RefCountPtr< RMF >& rmfData (size_t rmfNum) const;
      void rmfData (size_t rmfNum, const RefCountPtr< RMF >& value);

      //## Association: XSModel::Data::Detector::MultiARF%3A92DEB3009C
      //## Role: MultiResponse::effectiveArea%3A92DEB600C1
      //## Qualifier: rmfNum%3A92E0A802D3; size_t
      const std::vector<RealArray>& effectiveArea () const;
      void setEffectiveArea (const std::vector<RealArray>& value);
      const RealArray& effectiveArea (size_t rmfNum) const;
      void effectiveArea (size_t rmfNum, const RealArray& value);

      //## Association: XSModel::Data::Detector::<unnamed>%3AC10E5B034C
      //## Role: MultiResponse::source%3AC10E5C0289
      virtual SpectralData* source () const;
      virtual void source (SpectralData* value);

      //## Association: XSModel::Data::Detector::RmfFileNames pointer%3C055BF60282
      //## Role: MultiResponse::rmfNames%3C055BF800D0
      //## Qualifier: rmfNum%3C055D9F00BB; size_t
      const std::vector<std::string>& rmfNames () const;
      void setRmfNames (const std::vector<std::string>& value);
      const std::string& rmfNames (size_t rmfNum) const;
      void rmfNames (size_t rmfNum, const std::string& value);

      //## Association: XSModel::Data::Detector::ArfFileNames pointer%3C05632E03C9
      //## Role: MultiResponse::arfNames%3C0563300313
      //## Qualifier: rmfNum%3C05637D02D0; size_t
      const std::vector<std::string>& arfNames () const;
      void setArfNames (const std::vector<std::string>& value);
      const std::string& arfNames (size_t rmfNum) const;
      void arfNames (size_t rmfNum, const std::string& value);

  public:
    // Additional Public Declarations
      //## begin MultiResponse%3A92D99B0161.public preserve=yes
      //## end MultiResponse%3A92D99B0161.public

  protected:
    //## Constructors (generated)
      MultiResponse();

      MultiResponse(const MultiResponse &right);


    //## Other Operations (specified)
      //## Operation: setArrays%3A92DC28018D
      virtual void setArrays () = 0;

      //## Operation: setDescription%3A92DC32000C
      virtual void setDescription (size_t specNum, size_t groupNum) = 0;

      //## Operation: Swap%3A956B1F000D
      //## Exceptions: ()
      virtual void Swap (MultiResponse& right) throw ();

      //## Operation: combineRMF%3B990D4901C3
      void combineRMF (Real* cvUnion) const;

      //## Operation: eboundsMin%3BDDBEA70211
      virtual const RealArray& eboundsMin () const;

      //## Operation: eboundsMax%3BDDBEAC027D
      virtual const RealArray& eboundsMax () const;

      //## Operation: shiftEffectiveArea%414078E7011B
      virtual void shiftEffectiveArea (const RealArray& newEnergies);

      //## Operation: restoreEffectiveArea%414092C80396
      virtual void restoreEffectiveArea ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: currentRMF%3AC3BE1D02CD
      size_t currentRMF () const;
      void currentRMF (size_t value);

      //## Attribute: unionSize%3BB8808F0346
      size_t unionSize () const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::Detector::Noticed Response Elements%3DE5341D01C9
      //## Role: MultiResponse::noticedElements%3DE5341E02CB
      //## Qualifier: index%3DE5345F03AE; size_t
      const IntegerArray& noticedElements () const;
      int noticedElements (size_t index) const;

      //## Association: XSModel::Data::Detector::Noticed Response Element Position%3DE536EC037F
      //## Role: MultiResponse::noticedElemPos%3DE536EF019E
      //## Qualifier: index%3DE5375E0213; size_t
      const IntegerArray& noticedElemPos () const;
      int noticedElemPos (size_t index) const;

      //## Association: XSModel::Data::Detector::Starting Energies%3DE5380D022D
      //## Role: MultiResponse::energyStart%3DE5380F00D9
      //## Qualifier: index%3DE5383A01F8; size_t
      const IntegerArray& energyStart () const;
      int energyStart (size_t index) const;

      //## Association: XSModel::Data::Detector::Energy Run Sizes%3DE538490386
      //## Role: MultiResponse::energyRunLengths%3DE5384B0169
      //## Qualifier: index%3DE5386D0201; size_t
      const IntegerArray& energyRunLengths () const;
      int energyRunLengths (size_t index) const;

      //## Association: XSModel::Data::Detector::Channel of current Energy Run%3DE538C10358
      //## Role: MultiResponse::channelForRun%3DE538C300AF
      //## Qualifier: index%3DE538DD0389; size_t
      const IntegerArray& channelForRun () const;
      int channelForRun (size_t index) const;

    // Additional Protected Declarations
      //## begin MultiResponse%3A92D99B0161.protected preserve=yes
      //## end MultiResponse%3A92D99B0161.protected

  private:
    //## Assignment Operation (generated)
      MultiResponse & operator=(const MultiResponse &right);


    //## Other Operations (specified)
      //## Operation: copy%3A95690202E8
      virtual void copy (const MultiResponse& right) = 0;

      //## Operation: RMFremove%3B90134401D4
      virtual void RMFremove ();

      //## Operation: order%3B94E96001AA
      virtual bool order (const Response& right) const;

      //## Operation: convolve%3C3F16EE0123
      virtual void convolve (const RealArray& flux, const RealArray& fluxErr, RealArray& foldFlux, RealArray& foldFluxErr) const;

    // Additional Private Declarations
      //## begin MultiResponse%3A92D99B0161.private preserve=yes
      //## end MultiResponse%3A92D99B0161.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin MultiResponse::currentRMF%3AC3BE1D02CD.attr preserve=no  protected: size_t {U} 
      size_t m_currentRMF;
      //## end MultiResponse::currentRMF%3AC3BE1D02CD.attr

      //## begin MultiResponse::unionSize%3BB8808F0346.attr preserve=no  protected: size_t {U} 
      size_t m_unionSize;
      //## end MultiResponse::unionSize%3BB8808F0346.attr

    // Data Members for Associations

      //## Association: XSModel::Data::Detector::MultiRMF Pointer%3A92DCC100AF
      //## begin MultiResponse::rmfData%3A92DCC30005.role preserve=no  public: RefCountPtr< RMF > { -> 1..nRHgN}
      std::vector<RefCountPtr< RMF > > m_rmfData;
      //## end MultiResponse::rmfData%3A92DCC30005.role

      //## Association: XSModel::Data::Detector::MultiARF%3A92DEB3009C
      //## begin MultiResponse::effectiveArea%3A92DEB600C1.role preserve=no  public: RealArray { -> 1..nVHgN}
      std::vector<RealArray> m_effectiveArea;
      //## end MultiResponse::effectiveArea%3A92DEB600C1.role

      //## Association: XSModel::Data::Detector::<unnamed>%3AC10E5B034C
      //## begin MultiResponse::source%3AC10E5C0289.role preserve=no  public: SpectralData { -> 1RHgN}
      SpectralData* m_source;
      //## end MultiResponse::source%3AC10E5C0289.role

      //## Association: XSModel::Data::Detector::RmfFileNames pointer%3C055BF60282
      //## begin MultiResponse::rmfNames%3C055BF800D0.role preserve=no  public: std::string { -> 1..nRHgN}
      std::vector<std::string> m_rmfNames;
      //## end MultiResponse::rmfNames%3C055BF800D0.role

      //## Association: XSModel::Data::Detector::ArfFileNames pointer%3C05632E03C9
      //## begin MultiResponse::arfNames%3C0563300313.role preserve=no  public: std::string { -> 1..nRHgN}
      std::vector<std::string> m_arfNames;
      //## end MultiResponse::arfNames%3C0563300313.role

      //## Association: XSModel::Data::Detector::Noticed Response Elements%3DE5341D01C9
      //## begin MultiResponse::noticedElements%3DE5341E02CB.role preserve=no  protected: IntegerArray { -> 1..nRHN}
      IntegerArray m_noticedElements;
      //## end MultiResponse::noticedElements%3DE5341E02CB.role

      //## Association: XSModel::Data::Detector::Noticed Response Element Position%3DE536EC037F
      //## begin MultiResponse::noticedElemPos%3DE536EF019E.role preserve=no  protected: IntegerArray { -> 1..nRHN}
      IntegerArray m_noticedElemPos;
      //## end MultiResponse::noticedElemPos%3DE536EF019E.role

      //## Association: XSModel::Data::Detector::Starting Energies%3DE5380D022D
      //## begin MultiResponse::energyStart%3DE5380F00D9.role preserve=no  protected: IntegerArray { -> 1..nVHgN}
      IntegerArray m_energyStart;
      //## end MultiResponse::energyStart%3DE5380F00D9.role

      //## Association: XSModel::Data::Detector::Energy Run Sizes%3DE538490386
      //## begin MultiResponse::energyRunLengths%3DE5384B0169.role preserve=no  protected: IntegerArray { -> 1..nVHgN}
      IntegerArray m_energyRunLengths;
      //## end MultiResponse::energyRunLengths%3DE5384B0169.role

      //## Association: XSModel::Data::Detector::Channel of current Energy Run%3DE538C10358
      //## begin MultiResponse::channelForRun%3DE538C300AF.role preserve=no  protected: IntegerArray { -> 1..nVHgN}
      IntegerArray m_channelForRun;
      //## end MultiResponse::channelForRun%3DE538C300AF.role

      //## Association: XSModel::Data::Detector::savedMultiARF%41407B4A00ED
      //## Role: MultiResponse::savedEffectiveArea%41407B4C0215
      //## Qualifier: rmfNum%41407C3100D1; size_t
      //## begin MultiResponse::savedEffectiveArea%41407B4C0215.role preserve=no  private: RealArray { -> 1..nVHgN}
      std::vector<RealArray> m_savedEffectiveArea;
      //## end MultiResponse::savedEffectiveArea%41407B4C0215.role

    // Additional Implementation Declarations
      //## begin MultiResponse%3A92D99B0161.implementation preserve=yes
      //## end MultiResponse%3A92D99B0161.implementation

};

//## begin MultiResponse%3A92D99B0161.postscript preserve=yes
inline bool operator>(const MultiResponse::positionInfo& left,const MultiResponse::positionInfo& right)
{
   return (left.posValue > right.posValue);
}

//## end MultiResponse%3A92D99B0161.postscript

// Class MultiResponse::positionInfo 

// Class MultiResponse 


//## Other Operations (inline)
inline const MultiResponse* MultiResponse::toMultiResponse () const
{
  //## begin MultiResponse::toMultiResponse%43AC560D006A.body preserve=yes
   return this;
  //## end MultiResponse::toMultiResponse%43AC560D006A.body
}

//## Get and Set Operations for Class Attributes (inline)

inline size_t MultiResponse::currentRMF () const
{
  //## begin MultiResponse::currentRMF%3AC3BE1D02CD.get preserve=no
  return m_currentRMF;
  //## end MultiResponse::currentRMF%3AC3BE1D02CD.get
}

inline void MultiResponse::currentRMF (size_t value)
{
  //## begin MultiResponse::currentRMF%3AC3BE1D02CD.set preserve=no
  m_currentRMF = value;
  //## end MultiResponse::currentRMF%3AC3BE1D02CD.set
}

inline size_t MultiResponse::unionSize () const
{
  //## begin MultiResponse::unionSize%3BB8808F0346.get preserve=no
  return m_unionSize;
  //## end MultiResponse::unionSize%3BB8808F0346.get
}

//## Get and Set Operations for Associations (inline)

inline const std::vector<RefCountPtr< RMF > >& MultiResponse::rmfData () const
{
  //## begin MultiResponse::rmfData%3A92DCC30005.get preserve=no
  return m_rmfData;
  //## end MultiResponse::rmfData%3A92DCC30005.get
}

inline void MultiResponse::setRmfData (const std::vector<RefCountPtr< RMF > >& value)
{
  //## begin MultiResponse::setRmfData%3A92DCC30005.set preserve=no
  m_rmfData = value;
  //## end MultiResponse::setRmfData%3A92DCC30005.set
}

inline const RefCountPtr< RMF >& MultiResponse::rmfData (size_t rmfNum) const
{
  //## begin MultiResponse::rmfData%3A92DCC30005.qualget preserve=no
  return m_rmfData[rmfNum];
  //## end MultiResponse::rmfData%3A92DCC30005.qualget
}

inline void MultiResponse::rmfData (size_t rmfNum, const RefCountPtr< RMF >& value)
{
  //## begin MultiResponse::rmfData%3A92DCC30005.qualset preserve=no
  m_rmfData[rmfNum] = value;
  //## end MultiResponse::rmfData%3A92DCC30005.qualset
}

inline const std::vector<RealArray>& MultiResponse::effectiveArea () const
{
  //## begin MultiResponse::effectiveArea%3A92DEB600C1.get preserve=no
  return m_effectiveArea;
  //## end MultiResponse::effectiveArea%3A92DEB600C1.get
}

inline void MultiResponse::setEffectiveArea (const std::vector<RealArray>& value)
{
  //## begin MultiResponse::setEffectiveArea%3A92DEB600C1.set preserve=no
  m_effectiveArea = value;
  //## end MultiResponse::setEffectiveArea%3A92DEB600C1.set
}

inline const RealArray& MultiResponse::effectiveArea (size_t rmfNum) const
{
  //## begin MultiResponse::effectiveArea%3A92DEB600C1.qualget preserve=no
  return m_effectiveArea[rmfNum];
  //## end MultiResponse::effectiveArea%3A92DEB600C1.qualget
}

inline void MultiResponse::effectiveArea (size_t rmfNum, const RealArray& value)
{
  //## begin MultiResponse::effectiveArea%3A92DEB600C1.qualset preserve=yes
  m_effectiveArea[rmfNum].resize(value.size());
  m_effectiveArea[rmfNum] = value;
  //## end MultiResponse::effectiveArea%3A92DEB600C1.qualset
}

inline SpectralData* MultiResponse::source () const
{
  //## begin MultiResponse::source%3AC10E5C0289.get preserve=no
  return m_source;
  //## end MultiResponse::source%3AC10E5C0289.get
}

inline void MultiResponse::source (SpectralData* value)
{
  //## begin MultiResponse::source%3AC10E5C0289.set preserve=no
  m_source = value;
  //## end MultiResponse::source%3AC10E5C0289.set
}

inline const std::vector<std::string>& MultiResponse::rmfNames () const
{
  //## begin MultiResponse::rmfNames%3C055BF800D0.get preserve=no
  return m_rmfNames;
  //## end MultiResponse::rmfNames%3C055BF800D0.get
}

inline void MultiResponse::setRmfNames (const std::vector<std::string>& value)
{
  //## begin MultiResponse::setRmfNames%3C055BF800D0.set preserve=no
  m_rmfNames = value;
  //## end MultiResponse::setRmfNames%3C055BF800D0.set
}

inline const std::string& MultiResponse::rmfNames (size_t rmfNum) const
{
  //## begin MultiResponse::rmfNames%3C055BF800D0.qualget preserve=no
  return m_rmfNames[rmfNum];
  //## end MultiResponse::rmfNames%3C055BF800D0.qualget
}

inline void MultiResponse::rmfNames (size_t rmfNum, const std::string& value)
{
  //## begin MultiResponse::rmfNames%3C055BF800D0.qualset preserve=no
  m_rmfNames[rmfNum] = value;
  //## end MultiResponse::rmfNames%3C055BF800D0.qualset
}

inline const std::vector<std::string>& MultiResponse::arfNames () const
{
  //## begin MultiResponse::arfNames%3C0563300313.get preserve=no
  return m_arfNames;
  //## end MultiResponse::arfNames%3C0563300313.get
}

inline void MultiResponse::setArfNames (const std::vector<std::string>& value)
{
  //## begin MultiResponse::setArfNames%3C0563300313.set preserve=no
  m_arfNames = value;
  //## end MultiResponse::setArfNames%3C0563300313.set
}

inline const std::string& MultiResponse::arfNames (size_t rmfNum) const
{
  //## begin MultiResponse::arfNames%3C0563300313.qualget preserve=no
  return m_arfNames[rmfNum];
  //## end MultiResponse::arfNames%3C0563300313.qualget
}

inline void MultiResponse::arfNames (size_t rmfNum, const std::string& value)
{
  //## begin MultiResponse::arfNames%3C0563300313.qualset preserve=no
  m_arfNames[rmfNum] = value;
  //## end MultiResponse::arfNames%3C0563300313.qualset
}

inline const IntegerArray& MultiResponse::noticedElements () const
{
  //## begin MultiResponse::noticedElements%3DE5341E02CB.get preserve=no
  return m_noticedElements;
  //## end MultiResponse::noticedElements%3DE5341E02CB.get
}

inline int MultiResponse::noticedElements (size_t index) const
{
  //## begin MultiResponse::noticedElements%3DE5341E02CB.qualget preserve=no
  return m_noticedElements[index];
  //## end MultiResponse::noticedElements%3DE5341E02CB.qualget
}

inline const IntegerArray& MultiResponse::noticedElemPos () const
{
  //## begin MultiResponse::noticedElemPos%3DE536EF019E.get preserve=no
  return m_noticedElemPos;
  //## end MultiResponse::noticedElemPos%3DE536EF019E.get
}

inline int MultiResponse::noticedElemPos (size_t index) const
{
  //## begin MultiResponse::noticedElemPos%3DE536EF019E.qualget preserve=no
  return m_noticedElemPos[index];
  //## end MultiResponse::noticedElemPos%3DE536EF019E.qualget
}

inline const IntegerArray& MultiResponse::energyStart () const
{
  //## begin MultiResponse::energyStart%3DE5380F00D9.get preserve=no
  return m_energyStart;
  //## end MultiResponse::energyStart%3DE5380F00D9.get
}

inline int MultiResponse::energyStart (size_t index) const
{
  //## begin MultiResponse::energyStart%3DE5380F00D9.qualget preserve=no
  return m_energyStart[index];
  //## end MultiResponse::energyStart%3DE5380F00D9.qualget
}

inline const IntegerArray& MultiResponse::energyRunLengths () const
{
  //## begin MultiResponse::energyRunLengths%3DE5384B0169.get preserve=no
  return m_energyRunLengths;
  //## end MultiResponse::energyRunLengths%3DE5384B0169.get
}

inline int MultiResponse::energyRunLengths (size_t index) const
{
  //## begin MultiResponse::energyRunLengths%3DE5384B0169.qualget preserve=no
  return m_energyRunLengths[index];
  //## end MultiResponse::energyRunLengths%3DE5384B0169.qualget
}

inline const IntegerArray& MultiResponse::channelForRun () const
{
  //## begin MultiResponse::channelForRun%3DE538C300AF.get preserve=no
  return m_channelForRun;
  //## end MultiResponse::channelForRun%3DE538C300AF.get
}

inline int MultiResponse::channelForRun (size_t index) const
{
  //## begin MultiResponse::channelForRun%3DE538C300AF.qualget preserve=no
  return m_channelForRun[index];
  //## end MultiResponse::channelForRun%3DE538C300AF.qualget
}

//## begin module%3A92D9FC02A2.epilog preserve=yes
//## end module%3A92D9FC02A2.epilog


#endif
